include ..\disk.nfo
include ..\royale.nfo
FAT_SEC=(HEADS*CYLINDRES*SECTORS)/256+1

;   1 Sector   -> BOOTSECTOR+INFODISK
;  ?? Sectorz  -> FAT 16 BITS <= 256 sectors
;  ?? Sectorz  -> FILELIST (1rst entry=kernel.com)

main segment byte
     assume cs:main;ds:main

org 100h


debut:
  mov ax,0e0dh
  int 10h
  mov ax,0e0ah
  int 10h
;*** Load params ***
  mov si,80h
  lodsb
  xor ah,ah
  dec ax
  mov si,82h
  add si,ax
  mov byte ptr ds:[si],0
  std
boucle_t:
  cmp si,80h
  je done_t
  lodsb
  cmp al,'\'
  jne boucle_t
done_t:
  cld
  add si,2
  push si
  call texte
  pop si
  mov di,offset FileRoy
go2zero:
  lodsb
  stosb
  or al,al
  jne go2zero

;*** Chargement FileSystem ***
  mov ax,201h
  mov bx,offset INFODISK
  mov cx,1
  mov dx,DISK
  call int13h
  mov ax,201h
  call int13h
  jnc ok2
  jmp error
ok2:

;*** Open File ***
  mov dx,82h
  mov ax,3D00h
  int 21h
  jnc ok3
  jmp error
ok3:
  mov ds:[handle],ax


;*** Copy File ***
Boucle:
;*** Load 512 bytes ***
  mov ah,3Fh
  mov bx,ds:[handle]
  mov cx,512
  mov dx,offset Buffer_Disk
  int 21h
  or ax,ax
  jz close
  add ds:[fsize],ax
;*** Si pas erreur find a sector ***
find_a_sector:
;*** IF 1rst then store it in fileheader ***
  cmp word ptr ds:[first],FAT_EOF
  jnz not_first
  call DSK_FindFatEmpty
  mov ds:[first],ax
  jmp Save2old
;*** ELSE chainage avec old ***
not_first:
  mov ax,ds:[old_sector]
  call DSK_setchain
;*** save new old sector ***
Save2old:
  mov ds:[old_sector],ax
;*** Write 512 bytes ***
  add ax,FAT_SEC+1
  call DSK_nb2sector
  mov bx,offset Buffer_Disk
  mov ah,3
  call int13h
;*** LOOP ***
  jmp Boucle

;*** Close File ***
Close:
  mov ah,3Eh
  mov bx,ds:[handle]
  int 21h

;*** Find End of filelist ***
  mov ax,0                      ; root first filelist sector
nextfilelist:
  mov ds:[LAST_filelist_sec],ax                     ; save old here
  call DSK_getchain
  cmp ax,FAT_EOF
jne nextfilelist

;*** Update Filelist *** (pas de test de dbordement)
  mov ax,ds:[LAST_filelist_sec]                     ; last here
  add ax,FAT_SEC+1
  call DSK_nb2sector
  mov bx,offset Buffer_Disk
  mov ah,2
  call int13h
  mov di,offset Buffer_Disk
Next_entry:
  mov al,es:[di]
  add di,32
  or al,al
  jne Next_entry

;*** ADD the entry in filelist ***
  sub di,32
  mov si,offset FileRoy
  mov cx,32
  rep movsb
  cmp di,500+offset buffer_disk
  ja sector_full
  mov al,0
  stosb
  jmp write_it
sector_full:      ; last filelist sector : 0
  mov ax,ds:[LAST_filelist_sec]
  call DSK_setchain
  add ax,FAT_SEC+1
  call DSK_nb2sector
  mov bx,offset End_of_filelist
  mov ah,3
  call int13h
write_it:
  mov ax,ds:[LAST_filelist_sec]
  add ax,FAT_SEC+1
  call DSK_nb2sector
  mov bx,offset Buffer_Disk
  mov ah,3
  call int13h

  mov si,offset S_fin
  jmp fin
error:
  mov si,offset S_error
fin:
  call texte
  mov ax,4C00h
  int 21h

S_fin db ' done.',13,10,0
S_error db ' Prout !',7,13,10,0

; dl : n de disque (0,1,80h,81h)
; dh : tte (0..N-1)
; ch : cylindre/piste (0..N-1)
; cl : secteur (1..N)
; al : nombre de secteur
DSK_nb2sector:

  cmp ax,FAT_SEC+2
  jne @not
  push ax
  mov ax,0e2Ah
  int 10h
  pop ax
@not:

  push bx
  xor dx,dx
  xor ch,ch
  mov cl,SECTORS
  div cx
  inc dl
  mov cl,dl ;save sector here
  xor dx,dx
  mov bx,CYLINDRES
  div bx
  mov ch,dl ;cylindre
  shl dh,6  ;DH poids fort  (XX000000b)
  or cl,dh
  mov dh,al ;head
  mov dl,DISK
  mov al,1

  pop bx
ret

Old_Fat_sector dw 0

;*** Lire Chainage ***
; Entree : ax=FAT_nb
; Sortie : ax=new FAT_nb
DSK_getchain:
  xor dx,dx                     ; next sector !
  mov cx,256
  div cx           ; sector/256
  shl dx,1
  mov si,offset buffer_FAT
  add si,dx        ; si : address of new sector !
  inc ax           ; sector/256+1 (bootsector) -> fat cluster we want !
  cmp ax,ds:[old_fat_sector]
  je same_fat_sector
  mov ds:[old_fat_sector],ax
  call DSK_nb2sector
  mov bx,offset buffer_FAT
  mov ah,2h
  call int13h
same_fat_sector:
  lodsw                         ; ax sector !
ret


;*** Ecrire Chainage ***
; Entree : ax=FAT_nb
; Sortie : ax=new FAT_nb
DSK_setchain:
  xor dx,dx                     ; next sector !
  mov cx,256
  div cx           ; sector/256
  shl dx,1
  mov di,offset buffer_FAT
  add di,dx        ; di : address of new sector !
  inc ax           ; sector/256+1 (bootsector) -> fat cluster we want !
;  cmp ax,ds:[old_fat_sector]
;  je same_fat_sector2
  mov ds:[old_fat_sector],ax
  call DSK_nb2sector
  mov bx,offset buffer_FAT
  mov ah,2h
  call int13h
same_fat_sector2:
  call DSK_FindFatEmpty
  push ax
  mov ax,ds:[old_fat_sector]
  call DSK_nb2sector
  mov bx,offset buffer_FAT
  mov ah,2h
  call int13h
  pop ax
  stosw                         ; ax sector !
  push ax
  mov ax,ds:[old_fat_sector]
  call DSK_nb2sector
  mov bx,offset buffer_FAT
  mov ah,3h
  call int13h
  pop ax
ret


;*** Find a viable sector ! ***
;return in ax sector n (pas de test de dbordement !!!)
DSK_FindFatEmpty:
  mov ax,1
Find_next:
  push ax
  call DSK_nb2sector
  mov bx,offset Buffer_Fat_Find
  mov ah,2h
  call int13h

  mov si,offset Buffer_Fat_Find
  mov cx,256
go_search:
  lodsw
  cmp ax,FAT_EMPTY
  je sector_found
loop go_search

  pop ax
  inc ax
jmp Find_next

Sector_found:
  sub si,2
  mov word ptr ds:[si],FAT_EOF
  pop ax
  push ax
  call DSK_nb2sector
  mov bx,offset Buffer_Fat_Find
  mov ah,3
  call int13h
  sub si,offset Buffer_Fat_Find
  shr si,1
  pop ax
  dec ax
  shl ax,8
  add ax,si
ret

texte:
  lodsb
  mov ah,0eh
  int 10h
  or al,al
  jnz texte
ret

int13h:
  int 13h
  mov al,'o'
  jnb int13hend
  mov al,'x'
int13hend:
  mov ah,0eh
  int 10h
ret


Old_Sector dw ?
Cur_Sector dw ?
Handle     dw ?

FileRoy db 28 dup (0)
  fsize dw 0
  first dw FAT_EOF
        db 0

INFODISK:
  db 3 dup (0)                      ; jmp
  signature   db 10 dup (0)         ; "Royale OS."
  db 512 dup (0)

End_of_FileList dw 0
Last_FileLIST_SEc dw 0
Buffer_Disk      db 512 dup (?)
Buffer_Fat       db 512 dup (?)
Buffer_Fat_Find  db 512 dup (?)

main ends

end debut
