.386

main segment byte use16
     assume cs:main;ds:main

org 100h

extrn FLAT_install:near, FLAT_destall:near

debut:
  jmp installer

;************************* INT 68H = rMEM mANAGER ****************************

MEMTABLE dw ?   ; Segment of mem table !
BLOCKSIZE dw ?  ; Taille du block mini !

int68:

i0: ; =Test if installed= -> ah=0 if not, 1 if yes !
  cmp ah,0
  jne i1
  mov ah,1
  iret

query dd ?
testbit db ?

i1: ; =Allocate=
    ; Entre : ecx octets
    ; Sortie : 0:edi (edi=0 si erreur)
  cmp ah,1
  jne i2
  push ds si eax ebx ecx edx
  xor edx,edx
  mov eax,ecx
  xor ecx,ecx
  mov cx,cs:[BLOCKSIZE]
  div ecx
  or edx,edx
  je i1_NoReste
  inc eax
i1_NoReste:
  mov cs:[query],eax                        ; eax=nombre de blocks
  xor ebx,ebx
  xor ecx,ecx
  mov ds,cs:[MEMTABLE]
  xor si,si                                 ; ds:0 -> Mem table
  mov byte ptr cs:[testbit],1
  push ebx
i1_boucle:
  cmp byte ptr cs:[testbit],1
  jne i1_next
  lodsb
  or si,si                                  ; OVERFLOW ???
  jne i1_next
  add sp,4
  xor edi,edi
  jmp i1_end
i1_next:
  inc ebx
  test al,cs:[testbit]
  jnz i1_no
  inc ecx
  cmp ecx,cs:[query]
  jz i1_found
  jmp i1_yes
i1_no:
  add sp,4
  xor ecx,ecx
  push ebx
i1_yes:
  rol byte ptr cs:[testbit],1
  jmp i1_boucle
i1_found:
  mov ecx,cs:[query]
i1_mark:
  or al,byte ptr cs:[testbit]
  cmp byte ptr cs:[testbit],1
  jnz i1_mark_next
  dec si
  mov ds:[si],al
  dec si
  lodsb
i1_mark_next:
  ror cs:[testbit],1
  dec ecx
  jnz i1_mark
  dec si
  mov ds:[si],al
  pop ebx
  mov ax,cs:[BLOCKSIZE]
  cwd
  mul ebx
  add eax,1024*1024 *2   ; ajouter le mga de real MEM !
  mov edi,eax
i1_end:
  pop edx ecx ebx eax si ds
  iret

i2: ; =Dezallocate=
    ; edi, ecx octets
  cmp ah,2
  jne i3
  push ds si eax ecx edx
  xor edx,edx
  mov eax,ecx
  xor ecx,ecx
  mov cx,cs:[BLOCKSIZE]
  div ecx
  or edx,edx
  je i2_NoReste
  inc eax
i2_NoReste:
  mov cs:[query],eax                        ; eax=nombre de blocks
  xor edx,edx
  mov eax,edi
  sub eax,1024*1024 *2
  xor ecx,ecx
  mov cx,cs:[BLOCKSIZE]
  div ecx
  xor edx,edx
  mov ecx,8
  div ecx                                   ; offset= (edi-1024)/(BLOCKSIZE*8)
  mov ds,cs:[MEMTABLE]
  mov si,ax
  lodsb
  mov byte ptr cs:[testbit],11111110b
  mov cl,dl
  rol byte ptr cs:[testbit],cl
  mov ecx,cs:[query]
i2_unmark:
  and al,byte ptr cs:[testbit]
  cmp byte ptr cs:[testbit],01111111b
  jnz i2_unmark_next
  mov ds:[si-1],al
  lodsb
i2_unmark_next:
  rol cs:[testbit],1
  dec ecx
  jnz i2_unmark
  dec si
  mov ds:[si],al
  pop edx ecx eax si ds
  iret

i3:
  iret

int68_end:

;******************************** Installer **********************************

installer:

;*** INFOS ***
  mov si,offset S_Entete
  mov ah,1
  int 66h

;*** Check ***
  mov ah,0
  int 68h
  or ah,ah
  je not_installed
  mov si,offset S_Already
  jmp Error

not_installed:
;*** 64KB for MEMORY TABLE ***
  xor cx,cx
  mov ah,60
  int 66h
  mov ax,es
  or ax,ax
  jne mem_ok_1
  mov si,offset S_NoMemory
  jmp Error

mem_ok_1:
;*** EMPTY IT ***
  mov cs:[MEMTABLE],ax
  mov cx,4000h
  xor di,di
  xor eax,eax
  rep stosd

;*** GET PARAMS ***
  mov si,offset S_Mem
  mov ah,1
  int 66h
  lds si,cs:[0]
find_space:
  lodsb
  cmp al,20h
  jne find_space
  cmp byte ptr ds:[si],0
  jne param_ok
  push cs
  pop ds
  mov si,offset S_NOparam
  jmp error
param_ok:
  xor bx,bx
boucle:
  lodsb
  or al,al
  je boucle_end
  push ax
  mov ax,10
  mul bx
  mov bx,ax
  pop ax
  sub al,'0'
  add bl,al
  adc bh,0
  jmp boucle
boucle_end:
  mov dx,bx
  mov ah,4
  int 66h
  shl dx,1
  mov cs:[BLOCKSIZE],dx
  push cs
  pop ds
  mov si,offset S_Memsize
  mov ah,1
  int 66h

;*** MOVE INT68 in MEMORY ***
  mov cx,offset int68_end-offset debut
  mov ah,60
  int 66h
  mov ax,es
  or ax,ax
  jne MemOK
  mov es,cs:[MEMTABLE]
  xor cx,cx
  mov ah,61h
  int 66h                       ; dezallocate mem table
  mov si,offset S_NoMemory
  jmp Error
MemOK:
  mov si,offset debut
  xor di,di
  rep movsb

;*** SET INT68 TABLE ***
  push es
  xor ax,ax
  mov es,ax
  mov di,68h*4
  mov ax,offset int68
  stosw
  pop ax                ; segment of interrupt-16 to simulate 100h offset !
  sub ax,16
  stosw

;*** OK ***
  mov si,offset S_Int68_OK
  mov ah,1
  int 66h

;*** FLAT ***
  mov si,offset S_FLAT
  mov ah,1
  int 66h
  call FLAT_install

  retf


Error:
  mov ah,1
  int 66h
  retf


   S_Entete db 'Pilote RMEM - Version 0.1',13,10
            db 'Remerciements : '                                   ,13,10
            db '     Herman Dullink'                                ,13,10
            db '     Groningen (the emulator city; CPC, MSX, ZX :-)',13,10
            db '     the Netherlands'                               ,13,10
            db '     +31-50-132829'                                 ,13,10
            db '     csg669@wing.rug.nl (fast)'                     ,13,10
            db '     herman.dullink@prgbbs.idn.nl (1 day slower)'   ,13,10,0
      S_Mem db 'Taille mmoire initialise : ',0
  S_MemSize db 'MB.',13,10,0
  S_Already db 'Pilote RMEM dj install !',13,10,0
 S_NoMemory db 'Pas assez de mmoire conventionnelle !',13,10,0
  S_NoParam db 'Pas de paramtre !',13,10
            db 'Lancez "RMEM XX" o XX est la quantit de mmoire tendue en MB (ex : 128).',13,10,0
 S_Int68_Ok db 'Interruption 68h installe !',13,10,0
     S_FLAT db 'Passage en Mode Flat.',13,10,0

main ends

end debut
