;   1 Sector   -> BOOTSECTOR+INFODISK
;  ?? Sectorz  -> FAT 16 BITS <= 256 sectors
;  ?? Sectorz  -> 1rst FILELIST

include ..\royale.nfo

main segment byte
     assume cs:main;ds:main

org 100h


debut:                                  ; on stack : disk n
  push cs
  pop ds

;*** Set Interrupts ***
  call set_int66
  mov si,offset S_KERNEL_VER
  mov ah,1
  int 66h
  mov si,offset S_Int66_OK
  mov ah,1
  int 66h

  push cs
  pop es

;*** Load DISK infos ***
  mov si,offset S_Disknfo
  mov ah,1
  int 66h
  pop ax
  mov ah,40
  int 66h
  cmp ah,0
  je ok1
  mov si,offset S_notGOODdisk
  call error
ok1:
  mov si,offset S_GOODdisk
  mov ah,1
  int 66h

;*** Check for Kernel.ini ***
  mov si,offset F_INI
  mov ah,41
  int 66h
  cmp ah,0
  je ok2
  mov si,offset S_noInit
  call error
ok2:

;*** Allocate memory ***
  mov dx,es:[di+28]
  shr dx,9
  inc dx
  shl dx,9
  mov ah,4
  int 66h
  mov si,offset S_InitMem
  mov ah,1
  int 66h
  mov cx,dx
  mov ah,60
  int 66h
  mov ax,es
  mov ds:[segini],ax

;*** Load za FILE ***
  mov si,offset F_INI
  xor di,di
  mov ah,42
  int 66h

;*** Allocate memory for coms ***
  mov cx,0
  mov ah,60
  int 66h
  mov ax,es
  mov ds:[segcom],ax
  mov si,offset S_ComMem
  mov ah,1
  int 66h

;*** Load com ***
  mov byte ptr cs:[ofsini],0
nextcom:
  mov ax,0e0dh   
  int 10h
  mov ax,0e0ah
  int 10h        ; go line
  mov ds,cs:[segini]
  mov es,cs:[segcom]
  mov si,cs:[ofsini]
  mov es:[0],si
  mov es:[2],ds
Fname:
  lodsb
  cmp al,13
  je Fname_OK
  cmp al,32
  jne Fname
Fname_OK:
  mov cs:[curpos],si
  mov byte ptr ds:[si-1],0
  mov si,cs:[ofsini]
  mov di,100h
  mov ah,42
  int 66h
  cmp ah,0
  je Ffound

;*** Erreur ***
  mov ah,1
  int 66h
  push cs
  pop ds
  push si
  mov si,offset S_ComNotFound
  mov ah,1
  int 66h
  pop si
  mov ds,cs:[segini]
Go_Next:
  lodsb
  cmp al,10
  jne Go_Next
  mov cs:[ofsini],si
  jmp nextcom

;*** OK ***
Ffound:
  mov si,cs:[curpos]
  mov byte ptr ds:[si-1],32
Command_end:
  lodsb
  cmp al,10
  jne command_end
  mov byte ptr ds:[si-2],0
  mov cs:[ofsini],si

;*** Execute it ***
  push es
  pop ds                        ;set cs=ds=es for file
  push cs
  push offset nextcom           ;address to come back !
  push es
  push di
  retf

  jmp $

;*** Chaines de caractres ***

S_Kernel_Ver db '*** KERNEL VERSION 1.1 ***',13,10,0
S_Int66_OK db 'Gestionnaire d''interruption 66h install.',13,10,0
S_Disknfo db 'Chargement des informations du disque courant : ',0
S_GoodDisk db 'valide.',13,10,0
S_NotGoodDisk db 'non valide !',7,0
S_noInit db 'Kernel.ini non trouv !',0
S_InitMem db ' octets allous pour Kernel.ini.',13,10,0
S_ComMem db 'Mmoire alloue pour les applications.',13,10,0
S_ComNotFound db ' non trouv...',13,10,0

F_Ini db 'Kernel.ini',0
segcom dw 0
segini dw 0
ofsini dw 0
curpos dw 0

error:
  mov ah,1
  int 66h
  mov ah,0
  int 66h
  jmp $
ret

;*** Includes ***

set_int66:
  xor ax,ax
  mov es,ax
  mov di,66h*4
  mov ax,offset int66
  stosw
  mov ax,cs
  stosw
ret

int66:
  include texte.66    ;  0..19
  include divers.66   ; 20..39
  include disk.66     ; 40..59
  include memory.66   ; 60..79
iret

buf:


main ends
end debut
