.386

main segment use16
     assume cs:main


  org 100h

debut:
  jmp installer

;*** int 67 = multimedia pilote ***

int67:

i0: ; =INITALIZE SOUND CARD= (al=DMA, cx=port) NRC
  cmp ah,0
  jne i1
  mov cs:PORT,cx
  mov cs:DMA,al
iret

PORT dw 0
DMA db 0


i1: ; =RESET SOUND CARD=
  cmp ah,1
  jne i2
;*** Port[DSP_RESET] := 1 ***
;  mov dx,DSP_RESET
  mov dx,cs:[PORT]
  add dx,6h
  mov al,1
  out dx,al
;*** Port[DSP_RESET] := 0 ***
;  mov dx,DSP_RESET
  xor al,al
  out dx,al
;*** WriteDSP($D1) -> Speaker ON ***
  mov al,0D1h
  call WriteDSP
iret


i2: ; =PLAY_DMA_8_BITS= es:di, cx=size, dx=freq
  cmp ah,2
  jne i3
  mov cs:[Ssize],cx
  mov cs:[Sfreq],dx
;*** WriteDSP($40) -> Set time constant ***
  mov al,40h
  call WriteDSP
;*** WriteDSP(time constant) ***
  mov dx,0Fh
  mov ax,4240h
  div cs:[Sfreq]                     ; 1000000 div freq
  sub ax,256                         ; -256
  neg ax                             ; -
  call WriteDSP

;*** Port[$0A] := DMA+4 ***
  mov al,cs:[DMA]
  add al,4
  out 0Ah,al

;*** Port[$0C] := 0;
  xor al,al
  out 0Ch,al

;*** Port[$0B] := $48+DMA ***
  mov al,cs:[DMA]
  add al,48h
  out 0Bh,al

;*** Port[$02]:=Lo(offset) ***
  mov ax,es
  shl ax,4
  add ax,si
  out 02h,al
;*** Port[$02] := Hi(offset) ***
  mov al,ah
  out 02h,al

;*** Port[$03] := Lo(size) ***
  mov ax,cs:[Ssize]
  out 03h,al
;*** Port[$03] := Hi(size) ***
  mov al,ah
  out 03h,al

;*** Port[$83] := page ***
  mov ax,si
  shr ax,4
  mov bx,es
  add ax,bx
  shr ax,12
  mov dx,83h
  out dx,ax

;*** Port[$0A] := blaster.dma ***
  mov al,cs:[DMA]
  out 0Ah,al

;*** WriteDSP($14) -> Set 8-bit ***
  mov al,14h
  call WriteDSP

;*** WriteDSP(Lo(size)) ***
  mov ax,cs:[Ssize]
  call WriteDSP
;*** WriteDSP(Hi(size)) ***
  mov ax,cs:[Ssize]
  mov al,ah
  call WriteDSP

iret

Sfreq dw 0
Ssize dw 0


i3: iret




;**************************** Write AX to DSP ********************************
WriteDSP:
  push ax

;DSP_WRITE_DATA equ DSP_BASE+0Ch
  mov dx,cs:[PORT]
  add dx,0Ch
WaitDSP:
  in ax,dx
  and ax,80h
  or ax,ax
  jnz WaitDSP
  pop ax
  out dx,al
  ret

int67_end:



;*****************************************************************************

installer:
  mov si,offset S_VERSION
  mov ah,1
  int 66h

;*** MOVE INT67 in MEMORY ***
  mov cx,offset int67_end-offset debut
  mov ah,60
  int 66h
  mov si,offset debut
  xor di,di
  rep movsb

;*** SET INT67 TABLE ***
  push es
  xor ax,ax
  mov es,ax
  mov di,67h*4
  mov ax,offset int67
  stosw
  pop ax                ; segment of interrupt-16 to simulate 100h offset !
  sub ax,16
  stosw

;*** OK ***
  mov si,offset S_Int67_OK
  mov ah,1
  int 66h

;*** LOAD PARAMS ***
  lds si,cs:[0]
;  mov si,cs:[0]
;  mov ds,cs:[2]         ; get params adress
first_param:
  lodsb
  or al,al
  je no_params
  cmp al,32
  jne first_param

;*** CALC address
  xor ah,ah
  lodsb
  sub al,'0'
  mov cx,ax
  shl cx,4
  lodsb
  sub al,'0'
  add cx,ax
  shl cx,4
  lodsb
  sub al,'0'
  add cx,ax

;*** CALC DMA ***
  inc si
  lodsb
  sub al,'0'

  mov ah,0
  int 67h
  mov si,offset S_INT67_init
  jmp show_texte

no_params:
  mov si,offset S_INT67_noinit

show_texte:
  push cs
  pop ds
  mov ah,1
  int 66h
  retf

S_VERSION db 'Gestionnaire "Sound Blaster" [Version 0.B]',13,10,0
S_Int67_OK db 'Pilote son install : interruption 67h.',13,10,0
S_int67_init db 'Initialise !',13,10,0
S_int67_noinit db 'Non initialise...',13,10,0


main ends

end debut
